#ifndef SOURCEOPERATOR_HPP_
#define SOURCEOPERATOR_HPP_

#include <map>
#include <log4cxx/logger.h>
#include "OperatorImpl.hpp"
#include "JBossNettyAdapter.hpp"

class SourceOperator : public OperatorImpl, public GPBMessageListener
{
private:
    log4cxx::LoggerPtr logger;

    int sliceId;
    std::map<int, JBossNettyAdapter*>* channels;
    pthread_mutex_t* channelsLock;

public:
    SourceOperator();
    void init(int sliceId, int sliceUId, int bucketCount, char* param, int size);
    void onConnectAdapter(int portId, int sourceId, Collector* collector);
    void onReadAdapter(void* buf, int size, int sourceId, Collector* collector);
    void onMessage(void* buf, int size, int sliceId, Collector* collector);
    bool generate(Collector* collector);
    void process(int routingKey, void* eventIn, int size, void* state, Collector* collector);
    ~SourceOperator();
};


#endif
