#ifndef WORKEROPERATOR_HPP_
#define WORKEROPERATOR_HPP_

#include <log4cxx/logger.h>

#include "OperatorImpl.hpp"

#define WINDOWSIZE 3

class WorkerOperator : public OperatorImpl
{
private:
    log4cxx::LoggerPtr logger;

    class State
    {
    public:
        int count;
        int ticks[WINDOWSIZE];
    };

public:
    WorkerOperator();
    void* stateInit();
    int getStateSize(void* state);
    void freeState(void* state);
    void serializeState(void* state, std::list<Buffer*>* buffers);
    void* deserializeState(std::list<Buffer*>* buffers);
    void stateAccess(int routingKey, void* eventIn, int size, StateAccess* stateAccess);
    void process(int routingKey, void* eventIn, int size, void* state, Collector* collector);
    ~WorkerOperator();
};

#endif
